import Lib;
import Protocol;
using MAll;

class Inter extends SP {//}

	public static var MA = 12;
	var panelRes:EL;
	var panelResIcon:EL;
	var panelField:TF;
	
	var bar:Array<EL>;
	var lich:EL;	
	
	public var summonMenu:SP;
	public var summonButs:Array<ui.SummonBut>;	
	public static var me:Inter;
	
	public var underGroundMode = true;
	
	public function new() {
		super();
		me = this;

		
		summonButs = [];
		summonMenu = new SP();
		summonMenu.graphics.beginFill(0, 0.5);
		summonMenu.graphics.drawRect(-MA, -MA, 32, 1024);
		
		addChild(summonMenu);
		for ( i in 0...2 ) {
			
			var but = new ui.SummonBut(i, [GOBLIN, ORC][i]);
			but.x = ui.SummonBut.SIZE >> 1;
			but.y = 60 + i * (ui.SummonBut.SIZE+12);
			summonMenu.addChild(but);
			summonButs.push(but);
		}		
		
		//
		panelRes = new EL();
		panelRes.goto("inter",0,0);
		addChild(panelRes);
		x = y = MA;
		
		panelField = Tools.getField(0xFFFFFF,"alagard",16);
		panelRes.addChild(panelField);
		Filt.glow(panelField, 2, 4, 0);
		
		bar = [];
		for ( i in 0...3 ) {
			var el = new EL();
			el.goto(i, "lifebar",0,0);
			el.x = 3+i*3;
			el.y = 3;
			bar.push(el);
			addChild(el);
		}
		
		lich = new EL();
		lich.goto(1,"inter",0,0);
		lich.x = 0;
		lich.y = -11;
		addChild(lich);
		

		
	}

	
	public function maj() {
		
		panelField.text = Game.me.mineral + "";
		panelField.autosize();
		panelField.x = 32 - Std.int(panelField.textWidth*0.5);
		panelField.y = 18;
		
		// LIFE BAR
		var co = Game.me.lich.life / Game.me.lich.data.life;
		var ma = 3;
		var ww = 64 - 2 * ma;
		
		bar[1].width = Math.round(ww * co-6);
		bar[2].x = bar[1].x + bar[1].width;
		
		//
		majPrices();
		
	}
	
	
	public function majPrices() {
		for ( b in summonButs ) b.majPrice();
	}
	
	public function activeUnderground() {
		underGroundMode = true;
		for ( b in summonButs ) b.active();
		
	}
	public function deactiveUnderground() {
		underGroundMode = false;
		Main.clearButs();
	}
	
//{
}






