import Lib;
import Protocol;
import org.si.sion.SiONDriver;

using MAll;
class BmpGfx extends BMD{}



class Main {//}
	

	
	
	public static var mcw = 0;
	public static var mch = 0;
	
	public static var BUTS:Array<SP> = [];
	public static var gfx:pix.Store;
	public static var t:Int;
	public static var sion:SiONDriver;
	public static var sionplayed:Array<String> = [];
	
	public static var screen:BMP;

	public static var SFX_VOLUME = new flash.media.SoundTransform(1);
	public static var module:SP;
	
	static function main() {

		SFX_VOLUME.volume = Dev.SFX?1:0;
		Keyb.repeat = false;
		initTiles();
		initSion();
		
		
		Fx.FIT_PIX = true;
		haxe.Log.setColor(0xFF0000);
		
		// SCREEN
		/*
		screen = new BMP(new BMD(Main.WIDTH, Main.HEIGHT, false, 0xFF00FF));
		screen.scaleX = screen.scaleY = 2;
		flash.Lib.current.addChild(screen);
		*/

		//
		flash.Lib.current.addEventListener(flash.events.Event.ENTER_FRAME, update);
		Keyb.init();

		//
		sion.play("");
		onResize(null);
		//
		if ( Dev.TEST_GAME ) 	new Game();
		else					new Menu();
		
		
		
		flash.Lib.current.stage.addEventListener( flash.events.Event.RESIZE, onResize );
		
	}
	
	static function update(e) {
		sionplayed = [];
		var max = (Keyb.isDown( flash.ui.Keyboard.PAGE_UP ) && !Dev.FINAL )?40:1;
		if ( Dev.FINAL ) max = 1;		
		if ( max > 1 ) SFX_VOLUME.volume = 0;
		for ( i in 0...max ) loop();		
		if ( module != null && screen != null ) screen.bitmapData.draw(module);

	}
	static function loop() {
		t++;
		Fx.updateAll();
		EL.updateAnims();

	}
	
	// TILES
	static function initTiles() {
		
		gfx = new pix.Store( new BmpGfx(0, 0) );
		pix.Element.DEFAULT_STORE = gfx;
		gfx.makeTransp(0xFFFFFFFF);
		
		gfx.addIndex("hex");
		gfx.slice(0, 0, 32, 48, 8);
		gfx.addIndex("buildings"); 
		gfx.slice(0, 48, 32, 48, 12);		
		gfx.addIndex("path_highlight");
		gfx.slice(0, 96, 32, 48);
		gfx.addIndex("gameover");
		gfx.slice(368,208,256, 72);
		gfx.addIndex("title");
		gfx.slice(368, 288, 224, 144);
		gfx.addIndex("inter_but");
		gfx.slice(440, 144, 80, 24,1,2);
		gfx.addIndex("show_arrow");
		gfx.slice(472, 80, 8, 8, 2);	
		gfx.addIndex("tools");
		gfx.slice(504, 80, 24,24,3,2);		
		gfx.addIndex("summon_but");
		gfx.slice(520, 144, 32, 32, 3);
		gfx.addIndex("alt_buildings");
		gfx.slice(224, 0, 32, 48, 3);
		gfx.addIndex("hint_title");
		gfx.slice(624, 192, 104, 16);
		
		//FX
		gfx.addIndex("spark_blue");
		gfx.slice(464, 90, 3, 3, 2);
		gfx.addAnim("spark_blue", [0, 1], [2, 12]);
		gfx.addIndex("spark_heal");
		gfx.slice(464, 93, 3, 3, 3);
		gfx.addAnim("spark_heal", [0, 1,2], [2, 4, 4]);
		gfx.addIndex("death");
		gfx.slice(624, 208, 16,16,6,2);
		gfx.addAnim("death", [for(i in 0...12)i], [4,3,2]);
		
		
		gfx.addIndex("gas");
		gfx.slice(616, 128, 16,16, 6, 2);
		gfx.addAnim("gas",[0,1,2,3,4,5,6,7,8,9,10,11],[2]);
		/*
		gfx.addIndex("gob_walk");
		gfx.slice(0, 144, 24, 24, 2, 2);
		gfx.slice(0, 144, 24, 24);		
		gfx.addIndex("pioche");
		gfx.slice(72, 144, 24, 24, 3, 2);
		*/
		
		
		gfx.addIndex("proj");
		gfx.slice(320, 48, 8, 8, 3 );	
		
		gfx.addIndex("stones");
		gfx.slice(32, 96, 4, 4, 2, 2);	
		
		
		gfx.addIndex("round_but");
		gfx.slice(512, 0, 64, 64 );			
		gfx.addIndex("giant_ring");
		gfx.slice(576, 0, 128, 128 );		
		gfx.addIndex("ressources");
		gfx.slice(64, 96, 16, 16, 2 );		
		gfx.addIndex("panel_price");
		gfx.slice(192, 128, 32, 16, 2 );		
		gfx.addIndex("build_selector");
		gfx.slice(320, 0, 32, 40 );
		gfx.addIndex("hint_box");
		gfx.slice(368, 0, 128, 80 );
		gfx.addIndex("ladder");
		gfx.slice(352, 0, 8, 32 );
		gfx.addIndex("intrusion");
		gfx.slice(320, 40, 48, 8 );
		
		gfx.addIndex("archer");
		gfx.slice(368, 128, 24, 16, 3, 2 );
		gfx.addAnim("archer", [1, 2, 3, 4, 5, 0], [2]);
		gfx.addIndex("sorcerer");
		gfx.slice(368, 160, 24, 16, 3, 2 );
		gfx.addAnim("sorcerer", [1, 2, 3, 4, 5, 0], [2]);
		
		// INTER
		gfx.addIndex("inter");
		gfx.slice(440, 104, 64, 40 );	
		gfx.slice(440, 80, 24, 24 );	
		gfx.addIndex("lifebar");
		gfx.slice(464, 80, 3, 10);		
		gfx.slice(467, 80, 2, 10);		
		gfx.slice(469, 80, 3, 10);
		
		
		// ENTS
		gfx.addIndex("monsters");
		var id = 0;
		for ( o in Data.ENTS ) {
			gfx.slice(0, 144 + id * 24, 24, 24, 24,1);
			gfx.addAnim("run_"+id, [0, 1, 0, 2], [2]);
			id++;
		}
		
		
		//DEPREC
		gfx.addIndex("card");
		gfx.slice(160, 0, 48, 64 );	
		
	}

	// SION
	static var sionBank:Map<String,org.si.sion.SiONData> = new Map();
	public static function initSion() {
			
		sion = new SiONDriver();
		
		
		var set = function(a, b) sionBank.set(a, sion.compile(b));
		
		
		set("build", "%1@9,,,36l16ccc");
		set("wrong", "%1@4,40,,30 o2 g16c16");
		set("build_in", "%1@2,32,,30 v8 >c8<*a8");
		set("build_out", "%1@2,32,,31 v8 a8>*c8");
		set("build_ok", "%1@2,,,32 d16a");
		set("archer", "%1@9,30,,40 f8");
		set("ouch", "%1@1,,,35g10*>>g");
		set("pickaxe", "%1@9,,,32 a");
		set("collapse", "%1@9,,,28 b32d;");
		set("sorcerer", "#A=%1@4,24,,32 c8*>g;A;k8A;");
		set("tick_light", "%1@9,,,52e");
		set("begin", "#A=%1@2,,,28 l16 v12 ea<ea8;A;k8A;");
		set("climb_down", "#A=a48d;%1@9,,,38 l16 A))))))A))))A)))A");
		set("climb_up", "#A=a48d;%1@9,,,38 l16 v2A(((A((((A(((((A");
		set("shield", "%1@1,,,36 <<g");
		set("ressource", "%1@6d24,,,24v8%1@1,,,32v4g");
		
		
		set("test", "%1@9");
		//set("coin",			"%1@1o6c24g32");


	}
	static public function playSion(str, ?tempo = 1, ?level:Level) {
		if ( !Dev.SFX || ( level!= null && !level.visible ) ) return;
		for ( k in sionplayed ) if (k == str) return;
		sionplayed.push(str);
		sion.sequenceOn(sionBank.get(str),null,0,0,tempo);
	}

	// BUT
	public static function makeBut(trg:SP,f:Void->Void,?a:Void->Void,?b:Void->Void,?rect:flash.geom.Rectangle) {
		
		

		if ( rect == null ) rect = trg.getBounds(trg);
		
		
		var mc = new SP();
		mc.x = rect.x;
		mc.y = rect.y;
		mc.graphics.rect( 0xFF0000, rect.width, rect.height);
		flash.Lib.current.addChild(mc);		
		
		var cur = trg;
		while ( cur != null ) {				
			mc.x += cur.x;
			mc.y += cur.y;	
			//trace( cur.name + " "+cur.x+"   "+cur.parent);
			cur = cast cur.parent;
			
		}

		
		
		mc.scaleX = mc.scaleY = 2;
		mc.x *= 2;
		mc.y *= 2;
		mc.alpha = 0;
		mc.makeBut(f,a,b);
		

		
		BUTS.push(mc);
		
	}
	public static function clearButs() {
		for ( b in BUTS ) {
			b.removeEvents();
			b.remove();
		}
		BUTS  = [];
	}
	
	//
	public static function onResize(e) {
		
		mcw = Std.int(flash.Lib.current.stage.stageWidth*0.5);
		mch = Std.int(flash.Lib.current.stage.stageHeight*0.5);
		
		if ( screen != null ) {

			screen.bitmapData.dispose();
		}
		screen = new BMP(new BMD(mcw, mch, false, 0xFF00FF));
		screen.scaleX = screen.scaleY = 2;
		flash.Lib.current.addChild(screen);
		
		if ( module != null ) cast(module).onResize();
		
	}
	
	
//{
}


// THE RUNAWAY
// THE GLORIOUS ESCAPE OF THE LICH KING




