import Lib;
import Protocol;
using MAll;

class Menu extends SP {//}
	
	public static var BG_COLOR = 0x2B3367;
	var title:EL;
	var buts:Array <ui.But>;
	var dif:Int;
	
	public function new() {
		super();		
		Main.module = this;
		//var e = new fx.Fade(this, false, 0);
		//e.spc = 0.02;
		
		dif = -1;
		graphics.rect(BG_COLOR,Main.mcw,Main.mch);
		
		
		// TITLE
		title = new EL();
		title.goto("title");
		title.y = (title.currentFrame.height>>1)+8;
		addChild(title);
		
		// BUTS
		buts = [];
		for ( i in 0...3 ) {
			var name = "easy,normal,hard".split(",")[i];
			var but = new ui.But(name);
			buts.push( but);
			addChild(but);
			
		}
		
		credits = Tools.getField(0xFFFFFF,"emulogic",8);
		credits.text = "Made in 48h for the Ludum Dare 29";
		credits.autosize();
		addChild(credits);		
		//
		onResize();
		
		
		var e = new fx.Fade(Main.screen, true, 0);
		e.spc = 0.02;
		
		//trace(Data.MUSIC);
		Main.sion.play(haxe.Resource.getString("intro_music"));
		Main.sion.fadeIn(1);
		
		//

		
		
	}
	var credits:TF;
	function launchGame(i) {
		Main.sion.fadeOut(1);
		
		Level.RAY = 10 + i * 2;
		//Main.playSion("tick_light");
		Main.playSion("begin");
		dif = i;
		Main.clearButs();
		var spc = 0.08;
		var e = new fx.Move( title, title.x, -100, spc );
		e.curveIn(2);
		var wait = 6;
		for ( b in buts ) {
			var launch = function() {
				var e = new fx.Move(b, b.x, -32, spc);
				e.curveIn(2);
			}
			new fx.Wait(wait, launch);
			wait += 4;
		}
		
		new fx.Wait( wait + 16, launch );
		
		
		
		new fx.Alpha(credits, 0);
	}
	
	function launch() {
		
		
		new Game();
		var e = new fx.Fade( Main.screen, true,BG_COLOR);		
	}
	
	
	public function onResize() {
		if ( dif > -1 ) return;
		Main.clearButs();
		
		// TITLE
		title.x = Main.mcw * 0.5;
		
		// BUT
		var id = 0;		
		for ( b in buts ) {
			b.x = Std.int(Main.mcw - ui.But.WIDTH) >> 1;
			b.y = 176 + id * (ui.But.HEIGHT + 4);
			b.setAction(launchGame.bind(id));			
			id++;
		}
		
		//
		credits.x = Std.int(Main.mcw-credits.textWidth)>>1;
		credits.y = Main.mch - 12;
		
		
		
		// BG
		graphics.clear();
		graphics.rect(0x2B3367,Main.mcw,Main.mch);
	}
	
//{
}






