package fx;
import Lib;
import Protocol;
using MAll;

class Build extends Fx {//}

	var building:Building;
	
	public function new(bid,hex) {
		super();

		building = new Building(bid, hex);
		
		
		var ray = 20;
		var mask = new SP();
		mask.graphics.lineStyle();
		mask.graphics.beginFill(0xFF0000);
		for ( i in 0...6 ) {
			var an = i * 6.28 / 6 - 1.57;
			var func = mask.graphics.lineTo;
			if ( i == 0 ) {				
				mask.graphics.moveTo;
			}
			var x = Math.cos(an) * ray;
			var y = Math.sin(an) * ray;
			if ( i < 2 || i == 5) y -= 32;
			func( x, y );
		}
		mask.graphics.lineTo(0, -ray-32);
		
		
		Game.me.map.addChild(mask);
		hex.center(mask);
		
		building.mask = mask;
		
		var ty = building.y;
		building.y += 64;
		var e = new Move( building, building.x, ty);
		e.curveIn(0.5);
		e.onFinish = end;
	
		Main.playSion("build");
		
	}
	
	function end() {
	
		Game.me.map.removeChild(building.mask);
		building.mask = null;
		kill();


	}
	
//{
}





