package fx;
import Lib;
import Protocol;
using MAll;

class Fight extends GameFx {//}

	public static var RAY = 10;
	
	var a:Ent;
	var b:Ent;
	var att:Ent;
	var def:Ent;	
	var px:Float;
	var py:Float;
	
	var cur:Ent;
	
	public function new(a:Ent , b:Ent) {
		super();

		if ( a.x > b.x ) {
			var k = a;
			a = b ;
			b = k;
		}
		this.a = a;
		this.b = b;
	
		for ( e in [a, b] ) e.step = FIGHT;
	
		
		px = (a.x + b.x) * 0.5;
		py = (a.y + b.y) * 0.5;
		
		var spc = 0.05;
		
		var e = new Move( a, px - RAY, py, spc );
		a.skin.scaleX = e.tw.sx > e.tw.ex? -1:1;
		
		var e = new Move( b, px + RAY, py, spc );
		b.skin.scaleX = e.tw.sx > e.tw.ex? -1:1;
		e.onFinish = hello;

	}
	
	override function update() {
		super.update();
		switch(step) {
			case 0 :
				a.fxWalk();
				b.fxWalk();
				
			case 1 : // FIGHT
				var fr = 3 + (timer >> 1);
				att.setFrame(fr);
				if ( timer == 3 && def.alive ) {
					def.hit( att.getDamage(), (att==a?1:-1)*1.6 );
				}
				
				if ( timer == 12 ) {
					att.setFrame(0);
					if ( def.alive && att.alive ) {
						nextStep();
					}else end();
				}
				
			case 2 :
				if ( !def.alive || !att.alive ) end();
				else if ( timer == 20 ) next();
				
		}
	}
	
	function end() {
		Game.me.fxs.remove(this);
		kill();
		a.step = IDLE;
		b.step = IDLE;
		
	}
	
	function hello() {
		nextStep();
		a.skin.scaleX = 1;
		b.skin.scaleX = -1;
		
		nextStep();
		cur = [a, b][Std.random(2)];
		att = a;
		def = b;
		if ( Std.random(2) == 0 ) switchAtt();
		
		next();
	}
	
	function  switchAtt() {
		var k  = att;
		att = def;
		def = k;
	}
	
	function next() {
		switchAtt();
		nextStep();
		step = 1;
	}
	

	
//{
}





