package fx;
import Lib;
import Protocol;
using MAll;

class Projectile extends GameFx {//}


	var bx:Float;
	var by:Float;
	var target:Ent;
	
	var proj:EL;
	var id:Int;
	var damage:Int;
	public var jump:Int;
	public var orient:Bool;
	public var pierce:Bool;
	
	public function new(lvl:Level,id:Int,dam,x:Float,y:Float,trg) {
		super();
		this.id = id;
		damage = dam;
		bx = x;
		by = y;
		target = trg;
		pierce = false;
		proj = new EL();
		proj.goto(id, "proj");
		proj.x = bx;
		proj.y = by;
		lvl.dm.add(proj, DP_FX);
		
		jump = 0;
		orient = true;
	}
	
	override function update() {
		super.update();
		
		var c = curve(coef);		
		var ox = proj.x;
		var oy = proj.y;
		
		proj.x = bx * (1 - c) + target.x * c;
		proj.y = by * (1 - c) + target.y * c - Math.sin(c*3.14)*jump;
		
		var dx = proj.x - ox;
		var dy = proj.y - oy; 	
			
		if ( orient ) proj.rotation = Math.atan2(dy, dx)/0.0174;
					
		if ( coef == 1 ) {
			if( target.alive ) target.hit( damage, dx < 0? -1:1, pierce );
			proj.parent.removeChild(proj);
			kill();
		}
		
	}


	
//{
}





